def calculate_waste(days, production_days, coefficients):
    waste = [0.0] * (days + 1)  # Инициализируем список отходов

    for i in range(1, days + 1):
        if i in production_days:
            w = coefficients[i][0]  # Количество использованного сырья в i-й день
            waste[i] = (1 - coefficients[i][1]) * waste[i - 1] + coefficients[i][1] * w
        else:
            waste[i] = (1 - coefficients[i][1]) * waste[i - 1]

    return waste[1:]  # Возвращаем отходы начиная со второго дня

# Чтение вводных данных
days_count, production_count = map(int, input().split())
coefficients = {}
production_days = set()

for _ in range(production_count):
    day, material, coefficient = map(int, input().split())
    coefficients[int(day)] = (material, coefficient)
    production_days.add(int(day))

# Рассчитываем отходы
result = calculate_waste(days_count, production_days, coefficients)

# Вывод результата
for waste in result:
    print(f"{waste:.6f}", end=" ")
